
#ifndef CRAYONIZER_COMMON_H
#define CRAYONIZER_COMMON_H

#define _GNU_SOURCE 
#include "libUseful-2.0/libUseful.h"
#include <sys/types.h>
#include <glob.h>
#include <regex.h>

#define GLOBAL_CONFIG_FILE "/etc/crayonizer.conf"
#define USER_CONFIG_FILE ".crayonizer.conf"

typedef enum {NONE, BLACK, RED, GREEN, YELLOW, BLUE, MAGENTA, CYAN, WHITE};
extern char *Version;
extern int GlobalFlags;

//these go in highbytes of 'Crayon->Action->Attribs'
#define FLAG_HIDE			65536
#define FLAG_BOLD			131072
#define FLAG_FAINT		262144
#define FLAG_UNDER		524288
#define FLAG_BLINK		1048576
#define FLAG_INVERSE	2097152
#define FLAG_CAPS			4194304
#define FLAG_LOWERCASE 8388608


//these go in 'Crayon->Action->Flags'
#define FLAG_SET_XTITLE 1
#define FLAG_RESTORE_XTITLE 2
#define FLAG_SETSTR 4
#define FLAG_SETENV 8
#define FLAG_BASENAME 16

#define CRAYONE_NOOP 0
#define CRAYON_LINE 1
#define CRAYON_STRING 2
#define CRAYON_CMDLINE 3
#define CRAYON_VALUE 4
#define CRAYON_APPEND 5
#define CRAYON_MAPTO 6
#define CRAYON_LINEMAPTO 7
#define CRAYON_PREPEND 8
#define CRAYON_EXEC 9

typedef struct
{
char Op;
float Value;
char *String;
int Flags;
int Attribs;
} TAction;

//This structure holds all the information needed to crayon a line
typedef struct
{
int Type;
char *Match;
int ActionCount;
TAction *Actions;
} TCrayon;

#endif
